package com.tuoheng.airportGzdp.config;

import cn.hutool.core.util.ObjectUtil;
import com.tuoheng.airportGzdp.service.impl.TaskServiceImpl;
import com.tuoheng.airportGzdp.until.SpringUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import javax.websocket.*;
import java.net.URI;

@Component
@ClientEndpoint
@Slf4j
public class WebSocketClient {

    @Autowired
    WebSocket webSocket;
    public static Session session;
    @OnOpen
    public void onOpen(Session session) {
        this.session=session;
        System.out.println("Connected: " + session.getId());
    }

    @OnMessage
    public void onMessage(String message) {
        /*log.info("线程名称fa{}",Thread.currentThread().getName());
        System.out.println("Received message: " + message);*/
        if (ObjectUtil.isEmpty(webSocket)){
             webSocket = SpringUtil.getBean(WebSocket.class);
        }
        webSocket.sendAllMessage(message);
    }

    @OnError
    public void onError(Throwable throwable) {
        throwable.printStackTrace();
    }

    @Async
    public void connectWebsocket(String code) {
        WebSocketContainer container = ContainerProvider.getWebSocketContainer();
        try {
            if (session!=null&&session.isOpen()){
                return;
            }
            String url = SpringUtil.getProperty("websocketurl")+"/0:0:"+code;
             session = container.connectToServer(WebSocketClient.class, URI.create(url));
            //session.getBasicRemote().sendText("Hello, server!"); // 发送消息给服务器
            log.info("websocket请求地址{}",url);
            // 保持连接并接收多条消息
            long oldtime  = System.currentTimeMillis();
            while (true&&session.isOpen()) {
                Thread.sleep(1000); // 每隔一秒钟检查一次是否有新消息
                if (System.currentTimeMillis()-oldtime>3600000){
                    session.close();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void closeWebsocket() {
        try {
         //session.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
