package com.tuoheng.airportGzdp.controller;

import com.tuoheng.airportGzdp.common.JsonResult;
import com.tuoheng.airportGzdp.entity.AirlineFile;
import com.tuoheng.airportGzdp.service.IAirlineDataService;
import com.tuoheng.airportGzdp.service.IAirlineFileService;
import com.tuoheng.airportGzdp.service.ITaskService;
import com.tuoheng.airportGzdp.until.SslUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author tzs
 * @since 2021-03-13
 */
@RestController
@RequestMapping("/airline")
@Slf4j
public class AirLineController {
    @Autowired
    private IAirlineDataService airlineDataService;
    @Autowired
    private IAirlineFileService airlineFileService;
    /**
     * 获取轨迹
     */
    @RequestMapping("/getPointList")
    public JsonResult getInfo(Integer recordId){
        JsonResult jsonResult =  airlineDataService.getList(recordId);
        return jsonResult;
    }


    /**
     * 获取航线
     * @param id
     * @return
     */
    @GetMapping("/getLocationById")
    public JsonResult getLocation(int id) {
        try {
            List list = new ArrayList();
                AirlineFile airlineFile = airlineFileService.getById(id);
                String urls = airlineFile.getFileUrl();
                //File file = new File(url);
                URL url = new URL(urls);
                if("https".equalsIgnoreCase(url.getProtocol())){
                    SslUtils.ignoreSsl();
                }
                HttpURLConnection urlcon = (HttpURLConnection) url.openConnection();
                urlcon.connect();         //获取连接
                InputStream is = urlcon.getInputStream();
                BufferedReader br = new BufferedReader(new InputStreamReader(is));
                String st;
                while ((st = br.readLine()) != null) {
                    String[] location = st.split("\t");
                    if (location.length > 8) {
                        if (location[8].equals("0") || location[8].contains("0.00000")) {
                            continue;
                        }
                        Map map = new HashMap();
                        map.put("lat", location[8]);
                        map.put("lon", location[9]);
                        list.add(map);
                    }
                }
                br.close();
            return JsonResult.success(list);
        } catch (Exception e) {
            log.error("",e);
            return JsonResult.error(e.getMessage());
        }

    }
}
