package com.tuoheng.airportGzdp.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.tuoheng.airportGzdp.common.JsonResult;
import com.tuoheng.airportGzdp.until.HttpURLConnectionUtil;
import com.tuoheng.airportGzdp.vo.AirlineFileDto;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author tzs
 * @since 2021-03-13
 */
@RestController
@RequestMapping("/airportInterface")
@Slf4j
public class InterfaceController {
    @Value("${interfaceUrl}")
    private String interfaceUrl;

    /**
     * 任务列表
     */
    @RequestMapping("/taskByDroneId")
    public JSON getInfo(Integer droneId){
        HttpURLConnectionUtil httpURLConnectionUtil = new HttpURLConnectionUtil();
        String url = interfaceUrl+"/taskByDroneId?page=1&limit=1000&droneId="+droneId+"";
        String jsonResult =  httpURLConnectionUtil.doGet(url);
        log.info("请求返回值{}",jsonResult);
        return (JSON) JSON.parse(jsonResult);
    }

    /**
     * 任务执行 通过任务id
     * @param jsonTaskId
     * @return
     */
    @PostMapping("/executeTaskAnsy")
    public JSON returnExcResult(@RequestBody JSONObject jsonTaskId) {
        jsonTaskId.put("requestId",999);
        log.info(Thread.currentThread().getName() + jsonTaskId + "调用");
        HttpURLConnectionUtil httpURLConnectionUtil = new HttpURLConnectionUtil();
        String url = interfaceUrl+"/executeTaskAnsy";
        String jsonResult =  httpURLConnectionUtil.doPost(url, JSONObject.toJSONString(jsonTaskId));
        log.info("请求返回值{}",jsonResult);
        return (JSON) JSON.parse(jsonResult);
    }

    /**
     * 航线飞行 通过航线id
     * @param ob
     * @return
     */
    @PostMapping("/excuteByLineId")
    public JSON excuteByLineId(@RequestBody JSONObject ob) {
        ob.put("requestId",999);
        log.info(Thread.currentThread().getName() + ob + "调用");
        HttpURLConnectionUtil httpURLConnectionUtil = new HttpURLConnectionUtil();
        String url = interfaceUrl+"/excuteByLineId";
        String jsonResult =  httpURLConnectionUtil.doPost(url, JSONObject.toJSONString(ob));
        log.info("请求返回值{}",jsonResult);
        return (JSON) JSON.parse(jsonResult);
    }
    /**
     * 云台控制
     * @param order
     * @return
     */
    @PostMapping("/cameraCommand")
    public JSON cameraCommand(@RequestBody JSONObject order) {
        log.info("云台指令{}",order);
        HttpURLConnectionUtil httpURLConnectionUtil = new HttpURLConnectionUtil();
        String url = interfaceUrl+"/cameraCommand";
        String jsonResult =  httpURLConnectionUtil.doPost(url, JSONObject.toJSONString(order));
        log.info("云台请求返回值{}",jsonResult);
        return (JSON) JSON.parse(jsonResult);
    }

    /**
     * 获取航线列表
     * @param airlineFileDto
     * @return
     */
    @PostMapping("/getAirlineFileListForThird")
    public JSON getAirlineFileList(@RequestBody AirlineFileDto airlineFileDto) {
        log.info("云台指令{}",airlineFileDto);
        HttpURLConnectionUtil httpURLConnectionUtil = new HttpURLConnectionUtil();
        String url = interfaceUrl+"/getAirlineFileListForThird";
        String jsonResult =  httpURLConnectionUtil.doPost(url, JSONObject.toJSONString(airlineFileDto));
        log.info("云台请求返回值{}",jsonResult);
        return (JSON) JSON.parse(jsonResult);
    }
}
