package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tuoheng.airportGzdp.common.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.LinkedHashMap;

/**
 * <p>
 * 测流数据表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_airCurrent")
public class AirCurrent extends BaseEntity {

    private static final long serialVersionUID = 1L;

//    /**
//     * 测流数据表 主键id
//     */
//    private int id;

    /**
     * 飞行任务记录id
     */
    private int inspectionRecordId;

    /**
     * 机场id
     */
    private Integer airportId;

    /**
     * 航线文件id
     */
    private Integer airlineFileId;

    /**
     * 航线文件id 名称
     */
    @TableField(exist = false)
    private String airlineFileName;

    /**
     * 数据采集时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date airFlyTime;

    /**
     * 测站唯一编码 用于区分不同测站
     */
    private String st;

    /**
     * 测站类型
     */
    private String type;

    /**
     * 数据包流水号
     */
    private Integer serial;

    /**
     * 总瞬时流量
     */
    private Double q1;

    /**
     * 断面平均流速
     */
    private Double v1;

    /**
     * 垂线数量
     */
    private Integer vcnt;

    /**
     * 所有时间平均流速 记录vv01 - vvx所有的数据
     */
    private String vvx;

//    /**
//     * 添加人
//     */
//    private Integer createUser;
//
//    /**
//     * 创建时间
//     */
//    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
//    private Date createTime;
//
//    /**
//     * 更新人
//     */
//    private Integer updateUser;
//
//    /**
//     * 更新时间
//     */
//    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
//    private Date updateTime;
//
//    /**
//     * 有效标识
//     */
//    private Integer mark;
//
//    /**
//     * 航线文件id
//     */
//    private Integer tenantId;


    /**
     * 数据处理
     */
    @TableField(exist = false)
    private LinkedHashMap<String,String> vvMap;


}
