package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 航线文件表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_flight_data_task")
public class AirlineData {

    private static final long serialVersionUID = 1L;

    /* 主机Ip*/
    private String hostIp;
    /* 任务id*/
    private int inspectionId;
    /**
     * lng
     */
    private String lng;

    /**
     * lat
     */
    private String lat;

    /**
     * 高度
     */
    private String altitude;
    /**
     * 实时时间
     */
    private String timestamp;

    private long flyTime;

    @TableField(exist = false)
    private String requestId;

    @TableField(exist = false)
    private String hspeed;

    @TableField(exist = false)
    private String vspeed;

    @TableField(exist = false)
    private String ysingal;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private String createTime;

    //水平速度
    private String velocity;

    //垂直速度
    private String airspeed;

    private String dv;

    private String gps;
}
