package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * <p>
 * 航线文件表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_airline_file")
public class AirlineFile {

    private static final long serialVersionUID = 1L;

    private int id ;
    /**
     * 文件名称
     */
    private String fileName;

    /**
     * 文件地址
     */
    private String fileUrl;

    /**
     * 航线类型：1,航点航线;2,指点航线;3,指面航线
     */
    private Integer type;

    /**
     * 文件备注
     */
    private String note;

    /**
     * 航线距离
     */
    private Double distance;

    /**
     * 关联机场id
     */
    private Integer airportId;

}
