package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 机场表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_airport")
public class Airport implements Serializable {

    private static final long serialVersionUID = 1L;

    private int id;
    /**
     * 设备编号
     */
    private String code;

    /**
     * 设备名称
     */
    private String name;

    /**
     * 机场照片
     */
    private String image;

    /**
     * 外部监控地址
     */
    private String externalMonitorUrl;
    /**
     * 外部监控地址flv
     */
    private String flvExternalMonitorUrl;

    /**
     * 内部监控地址
     */
    private String internalMonitorUrl;

    /**
     * 覆盖范围
     */
    private String coverage;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 备注
     */
    private String note;

    /**
     * 经度
     */
    private String longitude;

    /**
     * 纬度
     */
    private String latitude;

    /**
     * 无人机ID
     */
    private Integer droneId;

    /**
     * 地面站url
     */
    private String groundStationUrl;
    /**
     * 控制板Id
     */
    private String edgeId;

    /**
     * mqtt控制板客户端Id
     */
    private String mqClientId;

    /*机场运行状态*/
    private int astatus;

    private String address;

    private int tenantId;

    private int mark;
}
