package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * <p>
 * 无人机表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_drone")
public class Drone  {

    private static final long serialVersionUID = 1L;

    private int id;
    /**
     * 设备编号
     */
    private String code;

    /**
     * 设备名称
     */
    private String name;

    /**
     * 无人机照片
     */
    private String image;

    /**
     * 机场ID
     */
    private String airportId;

    /**
     * 产品序号
     */
    private String productSn;

    /**
     * 动力类型：1电动 2油动 3混合
     */
    private Integer powerType;

    /**
     * 飞控序号
     */
    private String flightSn;

    /**
     * 产品类型：1多旋翼 2固定翼 3垂直起降
     */
    private Integer productType;

    /**
     * 产品等级：1微型 2轻型 3小型 4中型 5大型 6其他
     */
    private Integer productLevel;

    /**
     * 生产厂家
     */
    private String manufacturer;

    /**
     * 定位精度(单位：米)
     */
    private String accuracy;

    /**
     * 续航时间(单位：分钟)
     */
    private Integer lifeTime;

    /**
     * 状态：1正常 2停用
     */
    private Integer status;

    /**
     * 相机ID
     */
    private Integer cameraId;

    /**
     * 喊话器ID
     */
    private Integer megaphoneId;

    /**
     * 探照灯ID
     */
    private Integer searchlightId;

    /**
     * 可见光摄像头地址
     */
    private String cameraUrl;
    /**
     * 可见光摄像头地址
     */
    private String liveUrl;
    /**
     * 热成像摄像头地址 改 推流地址
     */
    private String thermalImageryUrl;

    /**
     * 直播地址-业务平台
     */
    private String playUrl;
    /**
     * 排序号
     */
    private Integer sort;

    /**
     * 电池代码
     */
    private String batteryCode;

}
