package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * <p>
 * 飞行任务记录表
 * </p>
 *
 * @author 拓恒
 * @since 2021-10-15
 */
@Data
@Accessors(chain = true)
@TableName("th_inspection_record")
public class InspectionRecord {

    private static final long serialVersionUID = 1L;

    /**
     * 任务编号
     */
    private String code;

    /**
     * 任务名称
     */
    private String name;

    /**
     * 执飞无人机ID
     */
    private Integer droneId;

    /**
     * 航线文件ID
     */
    private Integer airlineFileId;


    /**
     * 备注
     */
    private String note;

    /**
     * 任务状态：1待执行 2执行中
     */
    private Integer status;

    //任务来源
    private String taskSource;
    //任务类型
    private int type;

    //任务来源名称
    private String taskSourceName;

    //所属任务id
    private int taskId;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date startTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date endTime;

    private int aid;

    private String aname;
    /**
     * 飞行距离
     */
    private Double distance;

    /**
     * 飞行时长min
     */
    private String flytime;

    /**
     * 主键ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 添加人
     */
    private Integer createUser;

    /**
     * 创建时间
     */
//    @TableField(fill = FieldFill.INSERT_UPDATE)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;

    /**
     * 更新人
     */
    private Integer updateUser;

    /**
     * 更新时间
     */
//    @TableField(fill = FieldFill.INSERT_UPDATE)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;

    /**
     * 有效标识
     */
    private Integer mark;
    /**
     * 租户id
     */
    private Integer tenantId;
}
