package com.tuoheng.airportGzdp.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Author: ww
 * @CreateTime: 2023-11-07  14:28
 * @Description: 视频回放资源
 * @Version: 2.0.1
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("th_vedio_Inspectionrecord")
public class VedioInspectionRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 名称
     */
    private String name;

    /**
     * 视频url
     */
    private String url;

    /**
     * 开始录制时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date startTime;

    /**
     * 结束录制时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date endTime;

    /**
     * 所属任务记录
     */
    private Integer recordId;

    /**
     * 视频宽度
     */
    private String duration;

    /**
     * 视频高度
     */
    private Integer height;

    /**
     * 视频宽度
     */
    private Integer Width;
}
