package com.tuoheng.airportGzdp.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tuoheng.airportGzdp.common.JsonResult;
import com.tuoheng.airportGzdp.entity.AirlineData;
import com.tuoheng.airportGzdp.mapper.AirlineDataMapper;
import com.tuoheng.airportGzdp.service.IAirlineDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 航线文件表 服务实现类
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Service
public class AirlineDataServiceImpl extends ServiceImpl<AirlineDataMapper, AirlineData> implements IAirlineDataService {

    @Autowired
    private AirlineDataMapper airlineDataMapper;


    /**
     * 查询航线数据列表
     * @param recordId 查询条件
     * @return
     */
    @Override
    public JsonResult getList(int recordId) {
        // 查询条件
        QueryWrapper<AirlineData> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("record_id", recordId);
        queryWrapper.eq("mark", 1);
        queryWrapper.orderByAsc("id");
        // 分页设置
        IPage<AirlineData> page = new Page<>(1, Integer.MAX_VALUE);
        IPage<AirlineData> pageData = airlineDataMapper.selectPage(page, queryWrapper);
        return JsonResult.success(pageData);
    }
}
