package com.tuoheng.airportGzdp.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tuoheng.airportGzdp.entity.InspectionRecord;
import com.tuoheng.airportGzdp.mapper.InspectionRecordMapper;
import com.tuoheng.airportGzdp.service.IInspectionRecordService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.core.index.PathBasedRedisIndexDefinition;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;


/**
 * <p>
 * 飞行任务表 服务实现类
 * </p>
 *
 * @author 拓恒
 * @since 2021-10-15
 */
@Service
@Slf4j
public class InspectionRecordServiceImpl implements IInspectionRecordService {


    @Resource
    private InspectionRecordMapper inspectionRecordMapper;

    /**
     *
     * @return
     */
    @Override
    public List<InspectionRecord> getFirstRecord() {
        //查询最新一条的数据 且不是任务失败的
        QueryWrapper<InspectionRecord> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("mark", 1);
        queryWrapper.orderByDesc("create_time");
        queryWrapper.last("limit 1");
        // 分页查询
        IPage<InspectionRecord> page = new Page<>(1, 1);
        IPage<InspectionRecord> pageData = inspectionRecordMapper.selectPage(page, queryWrapper);
        return pageData.getRecords();
    }


}
