package com.tuoheng.airportGzdp.vo;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tuoheng.airportGzdp.common.BaseQuery;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * <p>
 * 测流数据表
 * </p>
 *
 * @author 拓恒
 * @since 2021-09-26
 */
@Data
public class AirCurrentDto extends BaseQuery {

    private static final long serialVersionUID = 1L;

    /**
     * 测流数据表 主键id
     */
    private Integer id;

    /**
     * 飞行任务记录id
     */
    private Integer inspectionRecordId;

    /**
     * 机场id
     */
    private Integer airportId;

    /**
     * 航线文件id
     */
    private Integer airlineFileId;

    /**
     * 数据采集时间
     */
    private Date airFlyTime;

    /**
     * 测站唯一编码 用于区分不同测站
     */
    private String st;

    /**
     * 测站类型
     */
    private String type;

    /**
     * 数据包流水号
     */
    private Integer serial;

    /**
     * 总瞬时流量
     */
    private Double q1;

    /**
     * 断面平均流速
     */
    private Double v1;

    /**
     * 垂线数量
     */
    private Integer vcnt;

    /**
     * 所有时间平均流速 记录vv01 - vvx所有的数据
     */
    private String vvx;

    /**
     * 添加人
     */
    private Integer createUser;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新人
     */
    private Integer updateUser;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 航线文件id
     */
    private Integer mark;

    /**
     * 有效标识
     */
    private Integer tenantId;


    /**
     * 流速开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private String startTime;

    /**
     * 流速结束时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private String endTime;

}
